#include <cstdio>
#include <iostream>
#include <cassert>
#include <vector>
#include <map>
#include <string>
#include <algorithm>
#include <sstream>
#include "testlib.h"

using namespace std;

string itoa(int x) 
{
    stringstream ss;
    string s;
    ss << x;
    ss >> s;
    return s;
}

int atoi(string s) 
{
    stringstream ss;
    int x;
    ss << s;
    ss >> x;
    return x;
}

void write_test(vector<int> test, int k) 
{
    cout << test.size() << ' ' << k << endl;
    for (int i = 0; i < (int)test.size() - 1; i++)
        cout << test[i] << ' ';
    cout << test.back() << endl;
}

void gen_rand(int n)
{
    vector<int> test(n);
    int sum = 0;
    bool is_one = false;
    for (int i = 0; i < n; i++)
    {
        test[i] = rnd.next(1, 2);
        if (i == n - 1)
            test[i] = (sum + 1) % 2 + 1;
        sum += test[i];
        is_one |= (test[i] == 1);
    } 
    shuffle(test.begin(), test.end());
    if (!is_one && sum % 4 != 0)
        test.push_back(2), sum += 2;
    write_test(test, sum / 2);
}


int main(int argc, char * argv[]) 
{
    registerGen(argc, argv, 1);
    int n = atoi(argv[1]);
    if (argc > 1 && atoi(argv[2]) == 1)
      n = rnd.next(n / 2, n);
    gen_rand(n);
    return 0;
}