import random
import math
random.seed("basic02/adrenaline")

class TestGen:
    def __init__(self):
        self.test_number = 0

    def generate_samples(self):
        self.print_test(8, 9)
        self.print_test(15, 12)

    def generate_min_tests(self):
        self.print_test(0, 1)
        self.print_test(1, 0)
        self.print_test(1, 1)
        self.print_test(3, 1)
        self.print_test(2, 2)
        self.print_test(2, 3)

    def generate_hand_tests(self):
        pass

    def generate_square_tests(self):
        for a in [30000, 30001, int(math.sqrt(10**9))]:
            self.print_test(a**2 // 2 - 1, a**2 // 2 - 1)
            self.print_test(a**2 // 2 - 1, a**2 // 2)
            self.print_test(a**2 // 2 - 1, a**2 // 2 + 1)
            self.print_test(a**2 // 2, a**2 // 2 - 1)
            self.print_test(a**2 // 2, a**2 // 2)
            self.print_test(a**2 // 2, a**2 // 2 + 1)
            self.print_test(a**2 // 2 + 1, a**2 // 2 - 1)
            self.print_test(a**2 // 2 + 1, a**2 // 2)
            self.print_test(a**2 // 2 + 1, a**2 // 2 + 1)

    def generate_random_test(self, n):
        self.print_test(random.randint(1, n), random.randint(1, n))

    def generate_max_tests(self, maxn):
        self.print_test(10**9, 10**9)

    def print_test(self, a, b):
        self.test_number += 1
        print('Generating test #%d' % self.test_number)
        test_name = "{0:0=2d}".format(self.test_number)
        test_file = open(test_name, 'w')
        print(a, b, file=test_file)
        test_file.close()

    def generate_all_tests(self):
        self.generate_samples()
        self.generate_min_tests()
        self.generate_hand_tests()

        for n in [5, 10, 50, 100, 1000, 10**5, 10**9]:
            for i in range(3):
                self.generate_random_test(n)
        self.generate_square_tests()
                
        self.generate_max_tests(10**9)

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)
