#ifdef LOCAL
#  define _GLIBCXX_DEBUG
#  define _GLIBCXX_DEBUG_PEDANTIC
#endif

#include "bits/stdc++.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }


void solve() {
	int n, q;
	cin >> n >> q;
	vector<int> powers;
	for (int i = 0; i < n; ++i) {
		int num;
		cin >> num;
		powers.push_back(num);
	}

	int bpv = 1;
	while (bpv < n) {
		bpv *= 2;
	}

	vector<pii> segtree(bpv * 2);
	vector<int> there(bpv * 2);

	set<int> left;

	for (int i = 0; i < n; ++i) {
		if (powers[i] > 1) {
			left.insert(i);
		}
		segtree[bpv + i] = {powers[i], i};
	}

	for (int i = bpv - 1; i > 0; --i) {
		segtree[i] = min(segtree[i * 2], segtree[i * 2 + 1]);
	}

	function<void(int, int, int, int, int, int)> segtree_add = [&](int v, int vl, int vr, int l, int r, int val) {
		if (vr <= l || r <= vl) {
			return;
		}
		if (l <= vl && vr <= r) {
			there[v] += val;
			segtree[v].ff += val;
			return;
		}
		if (there[v]) {
			there[v * 2] += there[v];
			there[v * 2 + 1] += there[v];
			segtree[v * 2].ff += there[v];
			segtree[v * 2 + 1].ff += there[v];
			there[v] = 0;
		}
		int vm = (vl + vr) / 2;
		segtree_add(v * 2, vl, vm, l, r, val);
		segtree_add(v * 2 + 1, vm, vr, l, r, val);
		segtree[v] = min(segtree[v * 2], segtree[v * 2 + 1]);
	};

	function<pii(int, int, int, int, int)> segtree_get = [&](int v, int vl, int vr, int l, int r) {
		if (vr <= l || r <= vl) {
			return make_pair(INF, -1);
		}
		if (l <= vl && vr <= r) {
			return segtree[v];
		}
		if (there[v]) {
			there[v * 2] += there[v];
			there[v * 2 + 1] += there[v];
			segtree[v * 2].ff += there[v];
			segtree[v * 2 + 1].ff += there[v];
			there[v] = 0;
		}
		int vm = (vl + vr) / 2;
		return min(segtree_get(v * 2, vl, vm, l, r), segtree_get(v * 2 + 1, vm, vr, l, r));
	};

	vector<tuple<int, int, int, int>> inp;
	for (int i = 0; i < q; ++i) {
		int type;
		cin >> type;
		if (type == 1) {
			int l, r;
			cin >> l >> r;
			--l;
			segtree_add(1, 0, bpv, l, r, -1);
			while (true) {
				pii tmp = segtree_get(1, 0, bpv, 0, n);
				if (tmp.ff > 1) {
					break;
				}
				left.erase(tmp.ss);
				segtree_add(1, 0, bpv, tmp.ss, tmp.ss + 1, INF);
			}
		} else {
			int l, r, x;
			cin >> l >> r >> x;
			--l;

			auto it = left.lower_bound(l);
			int ans = -1;
			while (it != left.end() && *it < r) {
				int pos = *it;
				x /= segtree_get(1, 0, bpv, pos, pos + 1).ff;
				if (!x) {
					ans = *it + 1;
					break;
				}
				++it;
			}

			cout << ans << "\n";
		}
	}
}


int main() {
	//freopen(TASK_NAME ".in", "r", stdin);
	//freopen(TASK_NAME ".out", "w", stdout);
	cerr << fixed << setprecision(15);
	cout << fixed << setprecision(15);
	ios::sync_with_stdio(false);

	int tests = 1;
	// cin >> tests;
	for (int it = 1; it <= tests; ++it) {
		solve();
	}
	
	#ifdef LOCAL
		cerr << "time: " << clock() << " ms\n";
	#endif
	return 0;
}