#include <bits/stdc++.h>
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)

using namespace std;

typedef long long ll;

const int dd = (int)1e6 + 7;

struct dsu {
	int r[dd], p[dd], ind[dd];
	
	dsu() { for (int i = 0; i < dd; i++) ind[i] = p[i] = i, r[i] = 1; }
	
	int get(int v) { return v == p[v] ? v : p[v] = get(p[v]); }
	int next(int v) { return ind[get(v)]; }
	void un(int a, int b) {
		a = get(a), b = get(b);
		if (a != b) {
			if (r[b] > r[a]) swap(a, b);
			p[b] = a, r[a] += r[b], ind[a] = max(ind[a], ind[b]);
		}
	}
} J;

struct SegmentTree {
	pair<int, int> T[4 * dd];
	int P[4 * dd];
	
	void build(int v, int tl, int tr, vector<int> &A) {
		if (tl == tr) T[v] = { A[tl], tl };
		else {
			int tm = (tl + tr) / 2;
			build(v * 2, tl, tm, A);
			build(v * 2 + 1, tm + 1, tr, A);
			T[v] = min(T[v * 2], T[v * 2 + 1]);
		}
	}
	
	void upd(int v, int tl, int tr, int l, int r, int val) {
		if (tl == l && tr == r) {
			T[v].first += val, P[v] += val;
		} else {
			int tm = (tl + tr) / 2;
			if (r <= tm) upd(v * 2, tl, tm, l, r, val);
			else if (l > tm) upd(v * 2 + 1, tm + 1, tr, l, r, val);
			else upd(v * 2, tl, tm, l, tm, val), upd(v * 2 + 1, tm + 1, tr, tm + 1, r, val);
			
			T[v] = min(T[v * 2], T[v * 2 + 1]);
			T[v].first += P[v];
		}
	}
	
	pair<int, int> mer(pair<int, int> a, int b) {
		a.first += b;
		return a;
	}
	
	pair<int, int> get(int v, int tl, int tr, int l, int r) {
		if (tl == l && tr == r) return T[v];
		int tm = (tl + tr) / 2;
		if (r <= tm) return mer(get(v * 2, tl, tm, l, r), P[v]);
		if (l > tm) return mer(get(v * 2 + 1, tm + 1, tr, l, r), P[v]);
		return mer(min(get(v * 2, tl, tm, l, tm), get(v * 2 + 1, tm + 1, tr, tm + 1, r)), P[v]);
	}
} T;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	
	int n, q;
	cin >> n >> q;
	
	vector<int> A(n);
	for (int i = 0; i < n; i++) {
		cin >> A[i];
		if (A[i] == 1) J.un(i, i + 1), A[i] = (int)1e9;
	}
	
	T.build(1, 0, n - 1, A);
	
	while (q--) {
		int tp, l, r;
		cin >> tp >> l >> r;
		l--, r--;
		
		if (tp == 1) {
			T.upd(1, 0, n - 1, l, r, -1);
			pair<int, int> tmp;
			while ((tmp = T.get(1, 0, n - 1, l, r)).first == 1) {
				T.upd(1, 0, n - 1, tmp.second, tmp.second, (int)1e9);
				J.un(tmp.second, tmp.second + 1);
			}
		} else {
			int x; cin >> x;
			
			int t = 0;
			for (int i = J.next(l); i <= r; i = J.next(i + 1)) {
				int c = T.get(1, 0, n - 1, i, i).first;
				x /= c;
				if (x == 0) {
					cout << i + 1 << "\n";
					t = 1;
					break;
				}
			}
			if (!t) cout << "-1\n";
		}
	}
	return 0;
}