#include "testlib.h"

#include <iostream>
#include <sstream>
#include <fstream>
#include <iomanip>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <ctime>
#include <climits>
#include <cassert>
#include <vector>
#include <queue>
#include <stack>
#include <deque>
#include <set>
#include <map>
#include <bitset>
#include <utility>
#include <algorithm>

#define forn(i, n) for (int i = 0; i < int(n); i++)

using namespace std;

const int N = 3e5 + 7;

vector <int> gr[N];
int dx[] = {0, 0, -1, 1};
int dy[] = {-1, 1, 0, 0};

int main(int argc, char* argv[])
{
    registerGen(argc, argv, 1);
    int n = atoi(argv[1]);
    int m = atoi(argv[2]);
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            for (int t = 0; t < 4; t++)
            {
                int x = i + dx[t], y = j + dy[t];
                if (x >= 0 && x < n && y >= 0 && y < m)
                {
                    int a = i * m + j;
                    int b = x * m + y;
                    gr[a].push_back(b);
                }
            }
        }
    }
    vector <int> perm(n * m);
    for (int i = 0; i < n * m; i++) perm[i] = i;
    shuffle(perm.begin(), perm.end());
    cout << n << ' ' << m << '\n';
    for (int i = 0; i < n * m; i++)
    {
        for (int j : gr[i])
        {
            if (perm[i] < perm[j])
            {
                cout << perm[i] + 1 << ' ' << perm[j] + 1 << '\n';
            }
        }
    }
    return 0;
}
