#ifdef LOCAL
#  define _GLIBCXX_DEBUG
#  define _GLIBCXX_DEBUG_PEDANTIC
#endif

#include "bits/stdc++.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }

int dx[4] = {1, 0, -1, 0};
int dy[4] = {0, 1, 0, -1};

void solve() {
	int n, m;
	cin >> n >> m;
	vector<set<int>> graph(n * m);
	set<pii> edges;
	vector<vector<int>> field;

	for (int i = 0; i < n * (m - 1) + m * (n - 1); ++i) {
		int a, b;
		cin >> a >> b;
		--a; --b;
		edges.insert({a, b});
		edges.insert({b, a});
		graph[a].insert(b);
		graph[b].insert(a);
	}

	if (n == 2 || m == 2) {
		m = n + m - 2;
		n = 2;
		int any1 = -1, any2 = -1;
		int cnt_corner = 0;
		for (int i = 0; i < n * m; ++i) {
			if (szof(graph[i]) == 1 || szof(graph[i]) > 3) {
				cout << "No\n";
				return;
			}
			if (szof(graph[i]) == 2) {
				++cnt_corner;
				if (any1 == -1) {
					any1 = i;
				} else if (any2 == -1 && graph[i].count(any1)) {
					any2 = i;
				}
			}
		}

		if (cnt_corner != 4 || any1 == -1 || any2 == -1) {
			cout << "No\n";
			return;
		}

		field = vector<vector<int>>(2, vector<int>(m, -1));
		field[0][0] = any1;
		field[1][0] = any2;
	} else {
		vector<bool> good(n * m);

		int cnt_good = 0;
		int any_good = -1;
		int cnt_corner = 0;
		for (int i = 0; i < n * m; ++i) {
			if (szof(graph[i]) == 1 || szof(graph[i]) > 4) {
				cout << "No\n";
				return;
			}
			if (szof(graph[i]) < 4) {
				good[i] = true;
				++cnt_good;
				any_good = i;
			}
			if (szof(graph[i]) == 2) {
				++cnt_corner;
			}
		}

		if (cnt_good != n * 2 + m * 2 - 4 || cnt_corner != 4) {
			cout << "nO\n";
			return;
		}

		for (int i = 0; i < n * m; ++i) {
			if (!good[i]) {
				continue;
			}
			int cnt = 0;
			for (int to : graph[i]) {
				if (good[to]) {
					++cnt;
				}
			}

			if (cnt != 2) {
				// cerr << i << " " << cnt << endl;
				cout << "no\n";
				return;
			}
		}

		// cerr << "here" << endl;

		vector<bool> used(n * m);
		vector<int> path;

		function<void(int)> dfs = [&](int v) {
			used[v] = true;
			path.push_back(v);
			for (int to : graph[v]) {
				if (!used[to] && good[to]) {
					dfs(to);
				}
			}
		};

		dfs(any_good);
		for (int i = 0; i < n * m; ++i) {
			if (good[i] && !used[i]) {
				cout << "NO\n";
				return;
			}
		}

		vector<int> corners;
		for (int i = 0; i < szof(path); ++i) {
			int next = (i + 1) % szof(path);
			if (!edges.count({path[i], path[next]})) {
				cout << "nO\n";
				return;
			}
			if (szof(graph[path[i]]) == 2) {
				corners.push_back(i);
			}
		}

		assert(szof(corners) == 4);

		if (corners[1] - corners[0] == corners[3] - corners[2] && corners[2] - corners[1] == corners[0] + szof(path) - corners[3]) {
			if (corners[1] - corners[0] == n - 1) {
				rotate(path.begin(), path.begin() + corners[0], path.end());
			} else if (corners[1] - corners[0] == m - 1) {
				rotate(path.begin(), path.begin() + corners[1], path.end());
			} else {
				cout << "no\n";
				return;
			}
		} else {
			cout << "NO\n";
			return;
		}

		field = vector<vector<int>>(n, vector<int>(m, -1));
		int c = 0;
		for (int i = 0; i < n; ++i) {
			field[i][0] = path[c++];
		}
		for (int i = 1; i < m; ++i) {
			field[n - 1][i] = path[c++];
		}
		for (int i = n - 2; i >= 0; --i) {
			field[i][m - 1] = path[c++];
		}
		for (int i = m - 2; i >= 1; --i) {
			field[0][i] = path[c++];
		}
	}

	for (int x = 0; x < n; ++x) {
		for (int y = 0; y < m; ++y) {
			if (field[x][y] == -1) {
				continue;
			}
			for (int d = 0; d < 4; ++d) {
				int nx = x + dx[d];
				int ny = y + dy[d];
				if (0 <= nx && nx < n && 0 <= ny && ny < m && field[nx][ny] != -1) {
					graph[field[x][y]].erase(field[nx][ny]);
					graph[field[nx][ny]].erase(field[x][y]);
				}
			}
		}
	}

	queue<pii> qu;

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (field[i][j] != -1 && szof(graph[field[i][j]]) == 1) {
				// cerr << "add " << i << " " << j << endl;
				qu.push({i, j});
			}
		}
	}

	while (szof(qu)) {
		int x, y;
		tie(x, y) = qu.front();
		// cerr << x << " " << y << endl;
		assert(field[x][y] != -1);
		qu.pop();
		if (szof(graph[field[x][y]]) == 0) {
			continue;
		}
		int memx = -1, memy = -1;
		for (int d = 0; d < 4; ++d) {
			int nx = x + dx[d];
			int ny = y + dy[d];
			if (0 <= nx && nx < n && 0 <= ny && ny < m && field[nx][ny] == -1) {
				memx = nx; memy = ny;
				break;
			}
		}
		assert(memx != -1);
		field[memx][memy] = *graph[field[x][y]].begin();
		for (int d = 0; d < 4; ++d) {
			int nx = memx + dx[d];
			int ny = memy + dy[d];
			if (0 <= nx && nx < n && 0 <= ny && ny < m && field[nx][ny] != -1) {
				if (!graph[field[nx][ny]].count(field[memx][memy])) {
					cout << "nO\n";
					return;
				}
				graph[field[nx][ny]].erase(field[memx][memy]);
				if (szof(graph[field[nx][ny]]) == 1) {
					qu.push({nx, ny});
				}

				graph[field[memx][memy]].erase(field[nx][ny]);
				if (szof(graph[field[memx][memy]]) == 1) {
					qu.push({memx, memy});
				}
			}
		}
	}

	// for (int i = 0; i < n; ++i) {
	// 	for (int j = 0; j < m; ++j) {
	// 		cerr << field[i][j] + 1 << " ";
	// 	}
	// 	cerr << endl;
	// }

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (field[i][j] == -1) {
				cout << "No\n";
				return;
			}
			for (int d = 0; d < 4; ++d) {
				int nx = i + dx[d];
				int ny = j + dy[d];
				if (0 <= nx && nx < n && 0 <= ny && ny < m) {
					if (!edges.count({field[i][j], field[nx][ny]})) {
						cout << "no\n";
						return;
					}
				}
			}
		}
	}

	cout << "YeS\n";
}


int main() {
	//freopen(TASK_NAME ".in", "r", stdin);
	//freopen(TASK_NAME ".out", "w", stdout);
	cerr << fixed << setprecision(15);
	cout << fixed << setprecision(15);
	ios::sync_with_stdio(false);

	int tests = 1;
	// cin >> tests;
	for (int it = 1; it <= tests; ++it) {
		solve();
	}
	
	#ifdef LOCAL
		cerr << "time: " << clock() << " ms\n";
	#endif
	return 0;
}