#include <cmath>
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <list>
#include <time.h>
#include <math.h>
#include <random>
#include <deque>
#include <queue>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <bitset>
#include <sstream>
#include <chrono>

using namespace std;

typedef long long ll;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 2e5 + 7;

int t[4 * N];
int d[4 * N];

void push(int v)
{
    t[v * 2 + 1] += d[v];
    d[v * 2 + 1] += d[v];
    t[v * 2 + 2] += d[v];
    d[v * 2 + 2] += d[v];
    d[v] = 0;
}

void upd(int v, int l, int r, int tl, int tr, int x)
{
    if (tl >= r || tr <= l)
    {
        return;
    }
    if (tl >= l && tr <= r)
    {
        d[v] += x;
        t[v] += x;
    }
    else
    {
        int tm = (tl + tr) / 2;
        push(v);
        upd(v * 2 + 1, l, r, tl, tm, x);
        upd(v * 2 + 2, l, r, tm, tr, x);
        t[v] = min(t[v * 2 + 1], t[v * 2 + 2]);
    }
}

int arr[2];

int main()
{
#ifdef ONPC
    freopen("a.in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++)
    {
        arr[0] = (m + 1) / 2;
        arr[1] = m / 2;
        if (i % 2) swap(arr[0], arr[1]);
        for (int c = 0; c < 2; c++)
        {
            if (!c)
            {
                upd(0, i + 1, n + 1, 0, n + 1, arr[c]);
            }
            else
            {
                upd(0, 0, i + 1, 0, n + 1, arr[c]);
            }
        }
    }
    map <pair <int, int>, int> col;
    int q;
    cin >> q;
    while (q--)
    {
        int x, y;
        cin >> x >> y;
        x--, y--;
        if (!col.count({x, y}))
        {
            col[{x, y}] = (x + y) % 2;
        }
        if (!col[{x, y}])
        {
            upd(0, x + 1, n + 1, 0, n + 1, -1);
        }
        else
        {
            upd(0, 0, x + 1, 0, n + 1, -1);
        }
        col[{x, y}] ^= 1;
        if (!col[{x, y}])
        {
            upd(0, x + 1, n + 1, 0, n + 1, 1);
        }
        else
        {
            upd(0, 0, x + 1, 0, n + 1, 1);
        }
        cout << t[0] << '\n';
    }
}
