#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, m, q;
    cin >> n >> m >> q;
    vector<int> cost(n + 1);
    vector<vector<int>> col(n, vector<int> (m));
    int cur = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            col[i][j] = ((i + j) & 1);
            cur += col[i][j];
        }
    }

    cost[0] = cur;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (col[i][j] == 1) {
                cur--;
            } else {
                cur++;
            }
        }
        cost[i + 1] = cur;
    }

    while (q--) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;

        int v = col[x][y] == 0 ? 1 : -1;

        for (int i = 0; i <= x; i++) {
            cost[i] += v;
        }
        for (int i = x + 1; i <= n; i++) {
            cost[i] -= v;
        }

        col[x][y] = 1 - col[x][y];

        cout << *min_element(cost.begin(), cost.end()) << "\n";
    }

    return 0;
}