#include <cmath>
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <list>
#include <time.h>
#include <math.h>
#include <random>
#include <deque>
#include <queue>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <bitset>
#include <sstream>
#include <chrono>

using namespace std;

typedef long long ll;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 5000 + 7;

int a[N], b[N], c[N];
vector <int> g[N];
int sz[N];
ll dp[N];
int tin[N], tout[N];
int value[N];
ll solve[2][2 * N];
int tt = 0;

void dfs(int v, int pr)
{
    tin[v] = tt++;
    value[tin[v]] = v;
    dp[v] = a[v];
    for (int to : g[v])
    {
        if (to != pr)
        {
            dfs(to, v);
            dp[v] += dp[to];
        }
    }
    tout[v] = tt;
    int sz = tout[v] - tin[v];
    for (int i = 0; i <= 2 * sz; i++)
    {
        solve[0][i] = solve[1][i] = -1e18;
    }
    solve[0][sz] = 0;
    int it = 0;
    priority_queue <int, vector <int>, greater <int> > q;
    ll sum = 0;
    for (int to : g[v])
    {
        if (to != pr)
        {
            for (int ind = tin[to] + 1; ind < tout[to]; ind++)
            {
                q.push(a[value[ind]]);
                sum += a[value[ind]];
            }
            for (int i = 0; i <= sz + sz; i++)
            {
                if (i >= b[to])
                {
                    solve[it ^ 1][i - b[to]] = max(solve[it ^ 1][i - b[to]], solve[it][i] + c[to]);
                }
                if (i + 1 <= sz + sz)
                {
                    solve[it ^ 1][i + 1] = max(solve[it ^ 1][i + 1], solve[it][i]);
                }
                solve[it ^ 1][i] = max(solve[it ^ 1][i], solve[it][i] + a[to]);
            }
            for (int i = 0; i <= sz + sz; i++)
            {
                solve[it][i] = -1e18;
            }
            it ^= 1;
        }
    }
    for (int i = sz + sz; i >= 0; i--)
    {
        if (i == 0)
        {
            solve[it][i] += a[v];
        }
        else
        {
            solve[it][i] = max(solve[it][i] + a[v], solve[it][i - 1]);
        }
    }
    dp[v] = max(dp[v], solve[it][sz] + sum);
    while (q.size() > 0)
    {
        sum -= q.top();
        sz--;
        dp[v] = max(dp[v], solve[it][sz] + sum);
        q.pop();
    }
}

int main()
{
#ifdef ONPC
    freopen("a.in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--)
    {
        int n;
        cin >> n;
        for (int i = 0; i < n; i++)
        {
            g[i].clear();
            cin >> a[i] >> b[i] >> c[i];
        }
        for (int i = 1; i < n; i++)
        {
            int u, v;
            cin >> u >> v;
            u--, v--;
            g[u].push_back(v);
            g[v].push_back(u);
        }
        dfs(0, -1);
        cout << dp[0] << '\n';
    }
}
